#include "stdafx.h"
#include "function.h"

void hdp_demo(){

	int L = 746316, W = 12419, burnin = 1000, thin = 10, NN = 500, K = 20;
	// Maximum number of topics
	int K_max = 3000;
	// Maximum number of iterations
	int max_iter = burnin + thin * NN;
	// Hyper-parameters 
	double a0 = 10.0, b0 = 10.0, a1 = 10.0, b1 = 10.0;
	double alpha0 = 1.0, alpha1 = 0.2, beta = 0.01;
	// Options 
	int learn_a0 = 0, learn_a1 = 0;

	// All those variables...
	int *jj, *ii, *zz, *ww, *K_vec, **m_jk, **N_jk, **N_kw, *N_k, *int_seq0, *int_seq1, prev_z, *max_zz;
	double **phi, **theta, *loglik, *pi, *z_pr, *m_k, **max_phi, **max_theta;
	double *k_vec, *w_vec, **ss, **log_ss, *m_pr;


	// random number seed
	const gsl_rng_type *T;
	gsl_rng *r;
	gsl_rng_env_setup();
	T = gsl_rng_default;
	r = gsl_rng_alloc(T);
	gsl_rng_set(r, (unsigned long)time(NULL));


	// Read data and memory allocation
	FILE *ifp;
	//ifp = fopen("C:\\Users\\JKH\\Desktop\\mw\\data\\nips.csv", "r") ;
	ifp = fopen("C:\\Users\\human\\Desktop\\hdp\\hdp\\nips.csv", "r");

	// L: number of items. 
	int **data = (int**)malloc(L*sizeof(int*));
	int N = 0;
	for (int i = 0; i<L; i++) {
		data[i] = (int*)malloc(3 * sizeof(int));
		//  first column: doc_idx
		// second column: word_idx
		//  thrid column: nr_word_per_doc
		fscanf(ifp, "%d,%d,%d", &data[i][0], &data[i][1], &data[i][2]);
		// number of TOTAL WORDS
		N += data[i][2];
	}
	fclose(ifp);

	// Indices of each word in TOTAL DOCUMENTS
	jj = (int*)malloc(N*sizeof(int)); // Document index
	ii = (int*)malloc(N*sizeof(int)); // Where is it located
	zz = (int*)malloc(N*sizeof(int)); // Topic index
	ww = (int*)malloc(N*sizeof(int)); //  ° ܾ? (numbering of each word)

	// Set jj, ii, ww
	int cnt = 0, n_j = 0, n_j_max = 0;
	int cnt2 = 0, p_j = -1;
	for (int i = 0; i<L; i++)	{ // For each word 
		if (p_j != data[i][0]){ // If document has changed, 
			if (cnt2>n_j_max) // 
				n_j_max = cnt2 - 1;
			cnt2 = 1;
			n_j++;
		}
		for (int j = 0; j<data[i][2]; j++){
			jj[cnt] = data[i][0];
			ii[cnt] = cnt2;
			ww[cnt] = data[i][1];
			cnt++;
			cnt2++;
		}
		p_j = data[i][0]; // Document idx 
	}

	// n_j_max: maximum number of words in a document 
	// sequences starting from 0 and 1, 
	int_seq0 = (int*)malloc(max(n_j_max, K_max)*sizeof(int));
	int_seq1 = (int*)malloc(max(n_j_max, K_max)*sizeof(int));
	for (int i = 0; i<max(n_j_max, K_max); i++)	{
		int_seq0[i] = i;
		int_seq1[i] = i + 1;
	}

	// Topic probabilities
	// W: Total size of dictionary 
	// phi: topic-word
	phi = (double**)malloc(K_max*sizeof(double*));
	for (int k = 0; k<K_max; k++)
		phi[k] = (double*)malloc(W*sizeof(double));
	// theta: document-topic
	theta = (double**)malloc(n_j*sizeof(double*));
	for (int j = 0; j<n_j; j++)
		theta[j] = (double*)malloc(K_max*sizeof(double));
	// Topics
	k_vec = (double*)malloc(K_max*sizeof(double));
	// Words
	w_vec = (double*)malloc(W*sizeof(double));

	// Topics for each thin
	K_vec = (int*)malloc(((max_iter - burnin) / thin)*sizeof(int));
	// Document count 
	m_k = (double*)malloc(n_j*sizeof(double));

	// Document topic index and count
	m_jk = (int**)malloc(n_j*sizeof(int*)); // Index
	N_jk = (int**)malloc(n_j*sizeof(int*)); // Count
	for (int j = 0; j<n_j; j++)	{
		m_jk[j] = (int*)malloc(K_max*sizeof(int));
		N_jk[j] = (int*)malloc(K_max*sizeof(int));
	}

	// Topic count 
	N_k = (int*)malloc(K_max*sizeof(int));
	// Topic word count 
	N_kw = (int**)malloc(K_max*sizeof(int*));
	for (int k = 0; k<K_max; k++)
		N_kw[k] = (int*)malloc(W*sizeof(int));

	// Log likelihood
	loglik = (double*)malloc(((max_iter - burnin) / thin)*sizeof(double));

	// Topic probability 
	pi = (double*)malloc(K_max*sizeof(double));
	z_pr = (double*)malloc(K_max*sizeof(double));

	// ??
	m_pr = (double*)malloc(n_j_max*sizeof(double));

	// ??
	ss = (double**)malloc((n_j_max + 1)*sizeof(double*));
	log_ss = (double**)malloc((n_j_max + 1)*sizeof(double));
	for (int i = 0; i<(n_j_max + 1); i++)	{
		ss[i] = (double*)malloc((i + 1)*sizeof(double));
		log_ss[i] = (double*)malloc((i + 1)*sizeof(double));
	}

	double *w_j = (double*)malloc(n_j*sizeof(double));
	double *s_j = (double*)malloc(n_j*sizeof(double));
	double eta;
	int *N_j = (int*)malloc(n_j*sizeof(int));
	double *aa0 = (double*)malloc(((max_iter - burnin) / thin)*sizeof(double));
	double *aa1 = (double*)malloc(((max_iter - burnin) / thin)*sizeof(double));

	max_phi = (double**)malloc(K_max*sizeof(double*));
	for (int k = 0; k<K_max; k++)
		max_phi[k] = (double*)malloc(W*sizeof(double));
	max_theta = (double**)malloc(n_j*sizeof(double*));
	for (int j = 0; j<n_j; j++)
		max_theta[j] = (double*)malloc(K_max*sizeof(double));
	double max_loglik = -1000000000.0;
	int max_K = 0;
	max_zz = (int*)malloc(N*sizeof(int));



	// (normalized) unsigned Stirling numbers of the first kind
	ss[0][0] = ss[1][1] = 1.0;
	for (int i = 1; i<(n_j_max + 1); i++)	{
		ss[i][0] = 0.0;
		for (int j = 1; j<(i + 1); j++)
			ss[i][j] = ss[i - 1][j - 1] + (i - 1)*ss[i - 1][j];
		double M = max_vec(ss[i], i + 1);
		for (int j = 1; j<(i + 1); j++)	{
			if ((ss[i][j - 1] > 0.0) && (ss[i][j - 1] < 1.0e-90))
				ss[i][j] = ss[i][j - 1] = 1.0e-91;
			else
				ss[i][j] /= M;
		}
	}

	log_ss[0][0] = log_ss[1][1] = 0.0;
	for (int i = 1; i<(n_j_max + 1); i++)	{
		for (int j = 1; j<(i + 1); j++)
			log_ss[i][j] = log(ss[i][j]);
	}


	// Initiallize
	for (int k = 0; k<K; k++)
		k_vec[k] = 1.0 / (double)K;
	for (int ind = 0; ind<N; ind++)
		zz[ind] = sample(int_seq1, k_vec, K, r);

	for (int j = 0; j<n_j; j++){
		N_j[j] = 0;
		for (int k = 0; k<K_max; k++)
			N_jk[j][k] = 0;
	}
	for (int k = 0; k<K_max; k++)	{
		N_k[k] = 0;
		for (int w = 0; w<W; w++)
			N_kw[k][w] = 0;
	}
	for (int t = 0; t<N; t++)	{
		jj[t] -= 1;
		ii[t] -= 1;
		zz[t] -= 1;
		ww[t] -= 1;
		N_jk[jj[t]][zz[t]] += 1;
		N_kw[zz[t]][ww[t]] += 1;
		N_k[zz[t]] += 1;
		N_j[jj[t]] += 1;
	}

	for (int k = 0; k<K + 1; k++)
		pi[k] = 1.0 / (double)(K + 1);


	// RUN MCMC 
	for (int iter = 0; iter<max_iter; iter++)	{
		printf("hdp_demo iter: %d \n", iter);

		// generate m_jk
		for (int j = 0; j<n_j; j++)	{
			for (int k = 0; k<K; k++)	{
				if (N_jk[j][k] > 0)	{
					for (int mm = 0; mm<N_jk[j][k]; mm++)
						m_pr[mm] = exp(log_ss[N_jk[j][k]][mm + 1] + (mm + 1)*(log(alpha1) + log(pi[k])));

					m_jk[j][k] = sample(int_seq1, m_pr, N_jk[j][k], r);
				}
				else
					m_jk[j][k] = 0;
			}
		}

		double m = 0.0;
		for (int k = 0; k<K; k++)	{
			m_k[k] = 0.0;
			for (int j = 0; j<n_j; j++){
				m_k[k] += (double)m_jk[j][k];
			}
			m += m_k[k];
		}


		// learn alpha1 and/or alpha0
		if (learn_a1 == 1 && learn_a0 == 1){
			for (int i = 0; i<50; i++)	{
				for (int j = 0; j<n_j; j++){
					w_j[j] = log(gsl_ran_beta(r, alpha1 + 1.0, (double)N_j[j]));
					s_j[j] = (double)rbernoulli((double)N_j[j] / (alpha1 + (double)N_j[j]), r);
				}
				alpha1 = gsl_ran_gamma(r, a1 + m - sum(s_j, n_j), 1.0 / (b1 - sum(w_j, n_j)));
				eta = log(gsl_ran_beta(r, alpha0 + 1.0, m));
				if (rbernoulli(1.0 / (1.0 + m*(b0 - eta) / (a0 + (double)K - 1.0)), r) == 1) {
					alpha0 = gsl_ran_gamma(r, a0 + (double)K, 1.0 / (b0 - eta));
				}
				else {
					alpha0 = gsl_ran_gamma(r, a0 + (double)K - 1.0, 1.0 / (b0 - eta));
				}
			}
		}
		else if (learn_a1 == 1){
			for (int i = 0; i<50; i++)	{
				for (int j = 0; j<n_j; j++){
					w_j[j] = log(gsl_ran_beta(r, alpha1 + 1.0, (double)N_j[j]));
					s_j[j] = (double)rbernoulli((double)N_j[j] / (alpha1 + (double)N_j[j]), r);
				}
				alpha1 = gsl_ran_gamma(r, a1 + m - sum(s_j, n_j), 1.0 / (b1 - sum(w_j, n_j)));
			}
		}
		else if (learn_a0 == 1){
			for (int i = 0; i<50; i++)	{
				eta = log(gsl_ran_beta(r, alpha0 + 1.0, m));
				if (rbernoulli(1.0 / (1.0 + m*(b0 - eta) / (a0 + (double)K - 1.0)), r) == 1) {
					alpha0 = gsl_ran_gamma(r, a0 + (double)K, 1.0 / (b0 - eta));
				}
				else {
					alpha0 = gsl_ran_gamma(r, a0 + (double)K - 1.0, 1.0 / (b0 - eta));
				}
			}
		}


		// generate pi	
		m_k[K] = alpha0;
		gsl_ran_dirichlet(r, K + 1, m_k, pi);


		// generate z
		for (int ind = 0; ind<N; ind++)	{
			prev_z = zz[ind];
			N_jk[jj[ind]][zz[ind]] -= 1;
			N_kw[zz[ind]][ww[ind]] -= 1;
			N_k[zz[ind]] -= 1;

			for (int k = 0; k<K; k++)
				z_pr[k] = ((double)N_jk[jj[ind]][k] + alpha1*pi[k]) * (beta + (double)N_kw[k][ww[ind]]) / ((double)W*beta + N_k[k]);
			z_pr[K] = alpha1*pi[K] / (double)W;

			zz[ind] = sample(int_seq0, z_pr, K + 1, r);

			N_jk[jj[ind]][zz[ind]] += 1;
			N_kw[zz[ind]][ww[ind]] += 1;
			N_k[zz[ind]] += 1;


			if (zz[ind] == K)	{
				K++;
				double tmp = pi[K - 1];
				pi[K - 1] = pi[K - 1] * gsl_ran_beta(r, 1.0, alpha0);
				pi[K] = tmp - pi[K - 1];
			}

			if (N_k[prev_z] == 0)	{
				if (prev_z == K - 1){
					pi[K - 1] += pi[K];
					pi[K] = 0.0;

					K--;
				}
				else{
					for (int j = 0; j<n_j; j++)	{
						N_jk[j][prev_z] = N_jk[j][K - 1];
						N_jk[j][K - 1] = 0;
					}
					for (int w = 0; w<W; w++)	{
						N_kw[prev_z][w] = N_kw[K - 1][w];
						N_kw[K - 1][w] = 0;
					}
					N_k[prev_z] = N_k[K - 1];
					N_k[K - 1] = 0;
					for (int ind2 = 0; ind2<N; ind2++)	{
						if (zz[ind2] == K - 1)
							zz[ind2] = prev_z;
					}

					double tmp = pi[K - 1];
					pi[K - 1] = pi[prev_z] + pi[K];
					pi[prev_z] = tmp;
					pi[K] = 0.0;

					K--;
				}
			}
		}
		if (iter%thin == 0){
			if (iter<burnin)	printf("%d %d %lf %lf\n", iter, K, alpha0, alpha1);
			else{
				// generate theta
				for (int j = 0; j<n_j; j++)	{
					for (int k = 0; k<K; k++)
						k_vec[k] = alpha1*pi[k] + (double)N_jk[j][k];
					gsl_ran_dirichlet(r, K, k_vec, theta[j]);
				}

				// generate phi
				for (int k = 0; k<K; k++)	{
					for (int w = 0; w<W; w++)
						w_vec[w] = beta + (double)N_kw[k][w];
					gsl_ran_dirichlet(r, W, w_vec, phi[k]);
				}

				//loglik
				loglik[(iter - burnin) / thin] = 0.0;
				for (int ind2 = 0; ind2<N; ind2++)	{
					double tmp = 0.0;
					for (int k = 0; k<K; k++)	{
						tmp += theta[jj[ind2]][k] * phi[k][ww[ind2]];
					}
					loglik[(iter - burnin) / thin] += log(tmp);
				}
				loglik[(iter - burnin) / thin] /= (double)N;

				aa0[(iter - burnin) / thin] = alpha0;
				aa1[(iter - burnin) / thin] = alpha1;
				K_vec[(iter - burnin) / thin] = K;
				printf("%d %d %lf %lf %lf\n", iter, K, alpha0, alpha1, loglik[(iter - burnin) / thin]);

				if (max_loglik<loglik[(iter - burnin) / thin]){
					max_loglik = loglik[(iter - burnin) / thin];
					max_K = K;

					for (int j = 0; j<n_j; j++)	{
						for (int k = 0; k<K; k++)
							max_theta[j][k] = theta[j][k];
					}

					for (int k = 0; k<K; k++)	{
						for (int w = 0; w<W; w++)
							max_phi[k][w] = phi[k][w];
					}

					for (int t = 0; t<N; t++)	max_zz[t] = zz[t];
				}
			}
		}
	}


	// SAVE OUTPUTS
	FILE *ofp1, *ofp2, *ofp3, *ofp4, *ofp5, *ofp6, *ofp7;
	ofp1 = fopen("C:\\Users\\human\\Desktop\\hdp\\K.txt", "w");
	ofp2 = fopen("C:\\Users\\human\\Desktop\\hdp\\loglik.txt", "w");
	ofp3 = fopen("C:\\Users\\human\\Desktop\\hdp\\alpha0.txt", "w");
	ofp4 = fopen("C:\\Users\\human\\Desktop\\hdp\\alpha1.txt", "w");
	ofp5 = fopen("C:\\Users\\human\\Desktop\\hdp\\theta.txt", "w");
	ofp6 = fopen("C:\\Users\\human\\Desktop\\hdp\\phi.txt", "w");
	ofp7 = fopen("C:\\Users\\human\\Desktop\\hdp\\z.txt", "w");
	for (int ind = 0; ind<(max_iter - burnin) / thin; ind++)	{
		fprintf(ofp1, "%d\n", K_vec[ind]);
		fprintf(ofp2, "%lf\n", loglik[ind]);
		fprintf(ofp3, "%lf\n", aa0[ind]);
		fprintf(ofp4, "%lf\n", aa1[ind]);
	}
	for (int j = 0; j<n_j; j++)	{
		for (int k = 0; k<max_K; k++)
			fprintf(ofp5, "%lf ", max_theta[j][k]);
		fprintf(ofp5, "%\n");
	}
	for (int k = 0; k<max_K; k++)	{
		for (int w = 0; w<W; w++)
			fprintf(ofp6, "%lf ", max_phi[k][w]);
		fprintf(ofp6, "%\n");
	}
	for (int t = 0; t<N; t++)	fprintf(ofp7, "%lf\n", max_zz[t]);
	fclose(ofp1);
	fclose(ofp2);
	fclose(ofp3);
	fclose(ofp4);
	fclose(ofp5);
	fclose(ofp6);
	fclose(ofp7);

	// FREE STUFFS 
	free(jj);
	free(ii);
	free(zz);
	free(ww);
	free(int_seq0);
	free(int_seq1);
	for (int k = 0; k<K_max; k++){
		free(max_phi[k]);
		free(phi[k]);
	}
	free(phi);
	for (int j = 0; j<n_j; j++){
		free(max_theta[j]);
		free(theta[j]);
	}
	free(theta);
	free(k_vec);
	free(w_vec);
	free(K_vec);
	for (int j = 0; j<n_j; j++)	{
		free(m_jk[j]);
		free(N_jk[j]);
	}
	free(m_jk);
	free(m_k);
	free(N_jk);
	free(N_k);
	for (int k = 0; k<K_max; k++)
		free(N_kw[k]);
	free(N_kw);
	free(loglik);
	free(pi);
	free(z_pr);
	for (int i = 0; i<(n_j_max + 1); i++)	{
		free(ss[i]);
		free(log_ss[i]);
	}
	free(ss);
	free(log_ss);
	free(m_pr);
	gsl_rng_free(r);

	free(w_j);
	free(s_j);
	free(aa0);
	free(aa1);
	free(max_zz);
}

double sum(double*x, int length)	{
	double res=0.0 ;
	for(int k=0; k<length; k++)
		res += x[k] ;
	return(res) ;
}

int sum(int*x, int length)	{
	int res=0 ;
	for(int k=0; k<length; k++)
		res += x[k] ;
	return(res) ;
}

int sum(int**x, int nrow, int ncol)	{
	int res=0 ;
	for(int i=0; i<nrow; i++)	{
		for(int j=0; j<ncol; j++)
			res += x[i][j] ;
	}
	return(res) ;
}
/*
int max(int a, int b)	{
	if(a > b)
		return(a) ;
	else
		return(b) ;
}
*/

double max_vec(double*vec, int length)	{
	double M = vec[0] ;
	for(int n=1; n<length; n++)
		if( M < vec[n] )
			M = vec[n] ;
	return(M) ;
}

double runif(gsl_rng *r, double min, double max)	{
	return(gsl_ran_flat (r, min, max)) ;
}

int rbernoulli(double prob, gsl_rng *r)	{
	if( runif(r) < prob )
		return(1) ;
	else
		return(0) ;
}

int sample(int*x, double*prob, int length, gsl_rng *r, bool normalized)	{
	
	double p=runif(r), cum=0.0, p_sum=0.0 ;

	if(normalized==false)	{
		for(int k=0; k<length; k++)
			p_sum += prob[k] ;
		for(int k=0; k<length; k++)
			prob[k] = prob[k]/p_sum ;
	}
	
	for(int k=0; k<length-1; k++)	{
		cum += prob[k] ;
		if(p < cum)
			return(x[k]) ;
	}
	return(x[length-1]) ;
}


void swap(int *x, int *y){
	int temp = *x;
	*x = *y;
	*y = temp;
	return;
}

void swap(double *x, double *y){
	double temp = *x;
	*x = *y;
	*y = temp;
	return;
}

void sort(double *x, int *index, int n, int l){
	double* y = (double*)malloc(n*sizeof(double));
	for (int i = 0; i<n; i++){
		y[i] = x[i];
		index[i] = i;
	}

	double max;
	int max_i;
	for (int i = 0; i<l; i++){
		max = y[i];
		max_i = i;
		for (int j = i + 1; j<n; j++){
			if (max<y[j]){
				max = y[j];
				max_i = j;
			}
		}
		swap(&y[i], &y[max_i]);
		swap(&index[i], &index[max_i]);
	}
	free(y);
	return;
}

