
#include "stdafx.h"
#include "hdp_mfc.h"
#include "hdp_mfcDlg.h"

// Hierarchical Dirichlet Process  ʱȭ 
void hdp::init(bool file_path_given)
{
	printf("[hdp->init()] \n");
	L = 746316;
	W = 12419;
	burnin = 10; // 1000;
	thin = 1; //  10;
	NN = 500; // 500
	K = 30;
	K_max = 3000;
	max_iter = burnin + thin * NN;
	a0 = 10.0;
	b0 = 1.0;
	a1 = 2.0;
	b1 = 1.0;
	alpha0 = 5.0;
	alpha1 = 1.0;
	beta = 0.1;
	// Flag
	learn_a0 = 0;
	learn_a1 = 0;

	// Random seed
	gsl_rng_env_setup();
	T = gsl_rng_default;
	r = gsl_rng_alloc(T);
	gsl_rng_set(r, (unsigned long)time(NULL));

	// File open
	if (!file_path_given)
		ifp = fopen("C:\\Users\\human\\Desktop\\hdp\\hdp\\nips.csv", "r");

	// L: number of items. 
	data = (int**)malloc(L*sizeof(int*));
	N = 0;
	for (int i = 0; i<L; i++) {
		data[i] = (int*)malloc(3 * sizeof(int));
		//  first column: doc_idx
		// second column: word_idx
		//  thrid column: nr_word_per_doc
		fscanf(ifp, "%d,%d,%d", &data[i][0], &data[i][1], &data[i][2]);
		// number of TOTAL WORDS
		N += data[i][2];
	}
	fclose(ifp);

	// Indices of each word in TOTAL DOCUMENTS
	jj = (int*)malloc(N*sizeof(int)); // Document index
	ii = (int*)malloc(N*sizeof(int)); // Where is it located
	zz = (int*)malloc(N*sizeof(int)); // Topic index
	ww = (int*)malloc(N*sizeof(int)); //  ° ܾ? (numbering of each word)

	// Set jj, ii, ww
	n_j = 0;
	int cnt = 0;
	n_j_max = 0;
	int cnt2 = 0, p_j = -1;
	for (int i = 0; i<L; i++)	{ // For each word 
		if (p_j != data[i][0]){ // If document has changed, 
			if (cnt2>n_j_max) // 
				n_j_max = cnt2 - 1;
			cnt2 = 1;
			n_j++;
		}
		for (int j = 0; j<data[i][2]; j++){
			jj[cnt] = data[i][0];
			ii[cnt] = cnt2;
			ww[cnt] = data[i][1];
			cnt++;
			cnt2++;
		}
		p_j = data[i][0]; // Document idx 
	}

	// n_j_max: maximum number of words in a document 
	// sequences starting from 0 and 1, 
	int_seq0 = (int*)malloc(max(n_j_max, K_max)*sizeof(int));
	int_seq1 = (int*)malloc(max(n_j_max, K_max)*sizeof(int));
	for (int i = 0; i<max(n_j_max, K_max); i++)	{
		int_seq0[i] = i;
		int_seq1[i] = i + 1;
	}

	// Topic probabilities
	// W: Total size of dictionary 
	// phi: topic-word
	phi = (double**)malloc(K_max*sizeof(double*));
	for (int k = 0; k<K_max; k++)
		phi[k] = (double*)malloc(W*sizeof(double));
	// theta: document-topic
	theta = (double**)malloc(n_j*sizeof(double*));
	for (int j = 0; j<n_j; j++)
		theta[j] = (double*)malloc(K_max*sizeof(double));
	// Topics
	k_vec = (double*)malloc(K_max*sizeof(double));
	// Words
	w_vec = (double*)malloc(W*sizeof(double));

	// Topics for each thin
	K_vec = (int*)malloc(((max_iter - burnin) / thin)*sizeof(int));
	// Document count 
	m_k = (double*)malloc(n_j*sizeof(double));

	// Document topic index and count
	m_jk = (int**)malloc(n_j*sizeof(int*)); // Index
	N_jk = (int**)malloc(n_j*sizeof(int*)); // Count
	for (int j = 0; j<n_j; j++)	{
		m_jk[j] = (int*)malloc(K_max*sizeof(int));
		N_jk[j] = (int*)malloc(K_max*sizeof(int));
	}

	// Topic count 
	N_k = (int*)malloc(K_max*sizeof(int));
	// Topic word count 
	N_kw = (int**)malloc(K_max*sizeof(int*));
	for (int k = 0; k<K_max; k++)
		N_kw[k] = (int*)malloc(W*sizeof(int));

	// Log likelihood
	curr_loglik = 0;
	loglik = (double*)malloc(((max_iter - burnin) / thin)*sizeof(double));

	// Topic probability 
	pi = (double*)malloc(K_max*sizeof(double));
	z_pr = (double*)malloc(K_max*sizeof(double));

	// ??
	m_pr = (double*)malloc(n_j_max*sizeof(double));

	// ??
	ss = (double**)malloc((n_j_max + 1)*sizeof(double*));
	log_ss = (double**)malloc((n_j_max + 1)*sizeof(double));
	for (int i = 0; i<(n_j_max + 1); i++)	{
		ss[i] = (double*)malloc((i + 1)*sizeof(double));
		log_ss[i] = (double*)malloc((i + 1)*sizeof(double));
	}

	w_j = (double*)malloc(n_j*sizeof(double));
	s_j = (double*)malloc(n_j*sizeof(double));
	N_j = (int*)malloc(n_j*sizeof(int));
	aa0 = (double*)malloc(((max_iter - burnin) / thin)*sizeof(double));
	aa1 = (double*)malloc(((max_iter - burnin) / thin)*sizeof(double));

	max_phi = (double**)malloc(K_max*sizeof(double*));
	for (int k = 0; k<K_max; k++)
		max_phi[k] = (double*)malloc(W*sizeof(double));
	max_theta = (double**)malloc(n_j*sizeof(double*));
	for (int j = 0; j<n_j; j++)
		max_theta[j] = (double*)malloc(K_max*sizeof(double));
	max_loglik = -1000000000.0;
	max_K = 0;
	max_zz = (int*)malloc(N*sizeof(int));

	// (normalized) unsigned Stirling numbers of the first kind
	ss[0][0] = ss[1][1] = 1.0;
	for (int i = 1; i<(n_j_max + 1); i++)	{
		ss[i][0] = 0.0;
		for (int j = 1; j<(i + 1); j++)
			ss[i][j] = ss[i - 1][j - 1] + (i - 1)*ss[i - 1][j];
		double M = max_vec(ss[i], i + 1);
		for (int j = 1; j<(i + 1); j++)	{
			if ((ss[i][j - 1] > 0.0) && (ss[i][j - 1] < 1.0e-90))
				ss[i][j] = ss[i][j - 1] = 1.0e-91;
			else
				ss[i][j] /= M;
		}
	}

	log_ss[0][0] = log_ss[1][1] = 0.0;
	for (int i = 1; i<(n_j_max + 1); i++)	{
		for (int j = 1; j<(i + 1); j++)
			log_ss[i][j] = log(ss[i][j]);
	}

	// Initiallize
	for (int k = 0; k<K; k++)
		k_vec[k] = 1.0 / (double)K;
	for (int ind = 0; ind<N; ind++)
		zz[ind] = sample(int_seq1, k_vec, K, r);

	for (int j = 0; j<n_j; j++){
		N_j[j] = 0;
		for (int k = 0; k<K_max; k++)
			N_jk[j][k] = 0;
	}
	for (int k = 0; k<K_max; k++)	{
		N_k[k] = 0;
		for (int w = 0; w<W; w++)
			N_kw[k][w] = 0;
	}
	for (int t = 0; t<N; t++)	{
		jj[t] -= 1;
		ii[t] -= 1;
		zz[t] -= 1;
		ww[t] -= 1;
		N_jk[jj[t]][zz[t]] += 1;
		N_kw[zz[t]][ww[t]] += 1;
		N_k[zz[t]] += 1;
		N_j[jj[t]] += 1;
	}

	for (int k = 0; k<K + 1; k++)
		pi[k] = 1.0 / (double)(K + 1);
} // init();

void hdp::init(int _L, int _W, int _burnin, int _thin, int _NN, int _K
	, double _a0, double _b0, double _a1, double _b1, double _alpha0, double _alpha1, double _beta
	, bool _learn_a0, bool _learn_a1)
{
	printf("[hdp->init()] \n");


	// 0  Default  ִ´. 
	if (_L == 0) L = def_L;					else  L = _L;
	if (_W == 0) W = def_W;					else  W = _W;
	if (_burnin == 0) burnin = def_burnin;	else  burnin = _burnin;
	if (_thin == 0) thin = def_thin;		else  thin = _thin;
	if (_NN == 0) NN = def_NN;				else  NN = _NN;
	if (_K == 0) K = def_K;					else  K = _K;
	K_max = 3000;
	if (_a0 == 0) a0 = def_a0;				else  a0 = _a0;
	if (_b0 == 0) b0 = def_b0;				else  b0 = _b0;
	if (_a1 == 0) a1 = def_a1;				else  a1 = _a1;
	if (_b1 == 0) b1 = def_b1;				else  b1 = _b1;
	if (_alpha0 == 0) alpha0 = def_alpha0;	else  alpha0 = _alpha0;
	if (_alpha1 == 0) alpha1 = def_alpha1;	else  alpha1 = _alpha1;
	if (_beta == 0) beta = def_beta;		else  beta = _beta;
	learn_a0 = _learn_a0;
	learn_a1 = _learn_a1;
	max_iter = burnin + thin * NN;

	printf("\n[hdp::init] Init HDP \n");
	printf("L: %d W: %d \n", L, W);
	printf("Burnin: %d Thin: %d NN: %d \n", burnin, thin, NN);
	printf("a0: %.1f b0: %.1f a1: %.1f b1: %.1f alpha0: %.1f alpha1: %.1f beta: %.1f \n", a0, b0, a1, b1, alpha0, alpha1, beta);


	// Random seed
	gsl_rng_env_setup();
	T = gsl_rng_default;
	r = gsl_rng_alloc(T);
	gsl_rng_set(r, (unsigned long)time(NULL));

	// File open (opend in load btn)
	// ifp = fopen("C:\\Users\\human\\Desktop\\hdp\\hdp\\nips.csv", "r");

	// L: number of items. 
	/*
	data = (int**)malloc(L*sizeof(int*));
	N = 0;
	for (int i = 0; i<L; i++) {
		data[i] = (int*)malloc(3 * sizeof(int));
		//  first column: doc_idx
		// second column: word_idx
		//  thrid column: nr_word_per_doc
		fscanf(ifp, "%d,%d,%d", &data[i][0], &data[i][1], &data[i][2]);
		// number of TOTAL WORDS
		N += data[i][2];
	}
	*/

	int L2 = 0; int W2 = 0;
	for (int i = 0 ; ; i++){
		int doc_idx, word_idx, nr_word;
		//  first column: doc_idx // second column: word_idx //  thrid column: nr_word_per_doc
		if (fscanf(ifp, "%d,%d,%d", &doc_idx, &word_idx, &nr_word) == EOF)
			break;
		// count number of items
		L2++;
		// Set W (#dictionary)
		if (word_idx > W2)
			W2 = word_idx;
	}
	printf("\n\n\n\n  L: %d L2: %d W: %d W2: %d  \n\n\n\n", L, L2, W, W2);
	L = L2;
	W = W2;
	
	rewind(ifp);
	data = (int**)malloc(L*sizeof(int*));
	N = 0;
	for (int i = 0; i < L; i++) {
		data[i] = (int*)malloc(3 * sizeof(int));
		//  first column: doc_idx
		// second column: word_idx
		//  thrid column: nr_word_per_doc
		if (fscanf(ifp, "%d,%d,%d", &data[i][0], &data[i][1], &data[i][2]) == EOF)
			break;
		// number of TOTAL WORDS
		N += data[i][2];
	}
	

	fclose(ifp);
	
	// Indices of each word in TOTAL DOCUMENTS
	jj = (int*)malloc(N*sizeof(int)); // Document index
	ii = (int*)malloc(N*sizeof(int)); // Where is it located
	zz = (int*)malloc(N*sizeof(int)); // Topic index
	ww = (int*)malloc(N*sizeof(int)); //  ° ܾ? (numbering of each word)

	// Set jj, ii, ww
	n_j = 0;
	int cnt = 0;
	n_j_max = 0;
	int cnt2 = 0, p_j = -1;
	for (int i = 0; i<L; i++)	{ // For each word 
		if (p_j != data[i][0]){ // If document has changed, 
			if (cnt2>n_j_max) // 
				n_j_max = cnt2 - 1;
			cnt2 = 1;
			n_j++;
		}
		for (int j = 0; j<data[i][2]; j++){
			jj[cnt] = data[i][0];
			ii[cnt] = cnt2;
			ww[cnt] = data[i][1];
			cnt++;
			cnt2++;
		}
		p_j = data[i][0]; // Document idx 
	}

	// n_j_max: maximum number of words in a document 
	// sequences starting from 0 and 1, 
	int_seq0 = (int*)malloc(max(n_j_max, K_max)*sizeof(int));
	int_seq1 = (int*)malloc(max(n_j_max, K_max)*sizeof(int));
	for (int i = 0; i<max(n_j_max, K_max); i++)	{
		int_seq0[i] = i;
		int_seq1[i] = i + 1;
	}

	// Topic probabilities
	// W: Total size of dictionary 
	// phi: topic-word
	phi = (double**)malloc(K_max*sizeof(double*));
	for (int k = 0; k<K_max; k++)
		phi[k] = (double*)malloc(W*sizeof(double));
	// theta: document-topic
	theta = (double**)malloc(n_j*sizeof(double*));
	for (int j = 0; j<n_j; j++)
		theta[j] = (double*)malloc(K_max*sizeof(double));
	// Topics
	k_vec = (double*)malloc(K_max*sizeof(double));
	// Words
	w_vec = (double*)malloc(W*sizeof(double));

	// Topics for each thin
	K_vec = (int*)malloc(((max_iter - burnin) / thin)*sizeof(int));
	// Document count 
	m_k = (double*)malloc(n_j*sizeof(double));

	// Document topic index and count
	m_jk = (int**)malloc(n_j*sizeof(int*)); // Index
	N_jk = (int**)malloc(n_j*sizeof(int*)); // Count
	for (int j = 0; j<n_j; j++)	{
		m_jk[j] = (int*)malloc(K_max*sizeof(int));
		N_jk[j] = (int*)malloc(K_max*sizeof(int));
	}

	// Topic count 
	N_k = (int*)malloc(K_max*sizeof(int));
	// Topic word count 
	N_kw = (int**)malloc(K_max*sizeof(int*));
	for (int k = 0; k<K_max; k++)
		N_kw[k] = (int*)malloc(W*sizeof(int));

	// Log likelihood
	curr_loglik = 0;
	loglik = (double*)malloc(((max_iter - burnin) / thin)*sizeof(double));

	// Topic probability 
	pi = (double*)malloc(K_max*sizeof(double));
	z_pr = (double*)malloc(K_max*sizeof(double));

	// ??
	m_pr = (double*)malloc(n_j_max*sizeof(double));

	// ??
	ss = (double**)malloc((n_j_max + 1)*sizeof(double*));
	log_ss = (double**)malloc((n_j_max + 1)*sizeof(double));
	for (int i = 0; i<(n_j_max + 1); i++)	{
		ss[i] = (double*)malloc((i + 1)*sizeof(double));
		log_ss[i] = (double*)malloc((i + 1)*sizeof(double));
	}

	w_j = (double*)malloc(n_j*sizeof(double));
	s_j = (double*)malloc(n_j*sizeof(double));
	N_j = (int*)malloc(n_j*sizeof(int));
	aa0 = (double*)malloc(((max_iter - burnin) / thin)*sizeof(double));
	aa1 = (double*)malloc(((max_iter - burnin) / thin)*sizeof(double));

	max_phi = (double**)malloc(K_max*sizeof(double*));
	for (int k = 0; k<K_max; k++)
		max_phi[k] = (double*)malloc(W*sizeof(double));
	max_theta = (double**)malloc(n_j*sizeof(double*));
	for (int j = 0; j<n_j; j++)
		max_theta[j] = (double*)malloc(K_max*sizeof(double));
	max_loglik = -1000000000.0;
	max_K = 0;
	max_zz = (int*)malloc(N*sizeof(int));

	// (normalized) unsigned Stirling numbers of the first kind
	ss[0][0] = ss[1][1] = 1.0;
	for (int i = 1; i<(n_j_max + 1); i++)	{
		ss[i][0] = 0.0;
		for (int j = 1; j<(i + 1); j++)
			ss[i][j] = ss[i - 1][j - 1] + (i - 1)*ss[i - 1][j];
		double M = max_vec(ss[i], i + 1);
		for (int j = 1; j<(i + 1); j++)	{
			if ((ss[i][j - 1] > 0.0) && (ss[i][j - 1] < 1.0e-90))
				ss[i][j] = ss[i][j - 1] = 1.0e-91;
			else
				ss[i][j] /= M;
		}
	}

	log_ss[0][0] = log_ss[1][1] = 0.0;
	for (int i = 1; i<(n_j_max + 1); i++)	{
		for (int j = 1; j<(i + 1); j++)
			log_ss[i][j] = log(ss[i][j]);
	}

	// Initiallize
	for (int k = 0; k<K; k++)
		k_vec[k] = 1.0 / (double)K;
	for (int ind = 0; ind<N; ind++)
		zz[ind] = sample(int_seq1, k_vec, K, r);

	for (int j = 0; j<n_j; j++){
		N_j[j] = 0;
		for (int k = 0; k<K_max; k++)
			N_jk[j][k] = 0;
	}
	for (int k = 0; k<K_max; k++)	{
		N_k[k] = 0;
		for (int w = 0; w<W; w++)
			N_kw[k][w] = 0;
	}
	for (int t = 0; t<N; t++)	{
		jj[t] -= 1;
		ii[t] -= 1;
		zz[t] -= 1;
		ww[t] -= 1;
		N_jk[jj[t]][zz[t]] += 1;
		N_kw[zz[t]][ww[t]] += 1;
		N_k[zz[t]] += 1;
		N_j[jj[t]] += 1;
	}

	for (int k = 0; k<K + 1; k++)
		pi[k] = 1.0 / (double)(K + 1);
} // init();


int hdp::mcmc(int iter)
{
	printf("[hdp->mcmc] iter: %d \n", iter);

	// generate m_jk
	for (int j = 0; j<n_j; j++)	{
		for (int k = 0; k<K; k++)	{
			if (N_jk[j][k] > 0)	{
				for (int mm = 0; mm<N_jk[j][k]; mm++)
					m_pr[mm] = exp(log_ss[N_jk[j][k]][mm + 1] + (mm + 1)*(log(alpha1) + log(pi[k])));

				m_jk[j][k] = sample(int_seq1, m_pr, N_jk[j][k], r);
			}
			else
				m_jk[j][k] = 0;
		}
	}

	double m = 0.0;
	for (int k = 0; k<K; k++)	{
		m_k[k] = 0.0;
		for (int j = 0; j<n_j; j++){
			m_k[k] += (double)m_jk[j][k];
		}
		m += m_k[k];
	}

	// learn alpha1 and/or alpha0
	if (learn_a1 == 1 && learn_a0 == 1){
		for (int i = 0; i<50; i++)	{
			for (int j = 0; j<n_j; j++){
				w_j[j] = log(gsl_ran_beta(r, alpha1 + 1.0, (double)N_j[j]));
				s_j[j] = (double)rbernoulli((double)N_j[j] / (alpha1 + (double)N_j[j]), r);
			}
			alpha1 = gsl_ran_gamma(r, a1 + m - sum(s_j, n_j), 1.0 / (b1 - sum(w_j, n_j)));
			eta = log(gsl_ran_beta(r, alpha0 + 1.0, m));
			if (rbernoulli(1.0 / (1.0 + m*(b0 - eta) / (a0 + (double)K - 1.0)), r) == 1) {
				alpha0 = gsl_ran_gamma(r, a0 + (double)K, 1.0 / (b0 - eta));
			}
			else {
				alpha0 = gsl_ran_gamma(r, a0 + (double)K - 1.0, 1.0 / (b0 - eta));
			}
		}
	}
	else if (learn_a1 == 1){
		for (int i = 0; i<50; i++)	{
			for (int j = 0; j<n_j; j++){
				w_j[j] = log(gsl_ran_beta(r, alpha1 + 1.0, (double)N_j[j]));
				s_j[j] = (double)rbernoulli((double)N_j[j] / (alpha1 + (double)N_j[j]), r);
			}
			alpha1 = gsl_ran_gamma(r, a1 + m - sum(s_j, n_j), 1.0 / (b1 - sum(w_j, n_j)));
		}
	}
	else if (learn_a0 == 1){
		for (int i = 0; i<50; i++)	{
			eta = log(gsl_ran_beta(r, alpha0 + 1.0, m));
			if (rbernoulli(1.0 / (1.0 + m*(b0 - eta) / (a0 + (double)K - 1.0)), r) == 1) {
				alpha0 = gsl_ran_gamma(r, a0 + (double)K, 1.0 / (b0 - eta));
			}
			else {
				alpha0 = gsl_ran_gamma(r, a0 + (double)K - 1.0, 1.0 / (b0 - eta));
			}
		}
	}


	// generate pi	
	m_k[K] = alpha0;
	gsl_ran_dirichlet(r, K + 1, m_k, pi);


	// generate z
	for (int ind = 0; ind<N; ind++)	{
		prev_z = zz[ind];
		N_jk[jj[ind]][zz[ind]] -= 1;
		N_kw[zz[ind]][ww[ind]] -= 1;
		N_k[zz[ind]] -= 1;

		for (int k = 0; k<K; k++)
			z_pr[k] = ((double)N_jk[jj[ind]][k] + alpha1*pi[k]) * (beta + (double)N_kw[k][ww[ind]]) / ((double)W*beta + N_k[k]);
		z_pr[K] = alpha1*pi[K] / (double)W;

		zz[ind] = sample(int_seq0, z_pr, K + 1, r);

		N_jk[jj[ind]][zz[ind]] += 1;
		N_kw[zz[ind]][ww[ind]] += 1;
		N_k[zz[ind]] += 1;


		if (zz[ind] == K)	{
			K++;
			double tmp = pi[K - 1];
			pi[K - 1] = pi[K - 1] * gsl_ran_beta(r, 1.0, alpha0);
			pi[K] = tmp - pi[K - 1];
		}

		if (N_k[prev_z] == 0)	{
			if (prev_z == K - 1){
				pi[K - 1] += pi[K];
				pi[K] = 0.0;

				K--;
			}
			else{
				for (int j = 0; j<n_j; j++)	{
					N_jk[j][prev_z] = N_jk[j][K - 1];
					N_jk[j][K - 1] = 0;
				}
				for (int w = 0; w<W; w++)	{
					N_kw[prev_z][w] = N_kw[K - 1][w];
					N_kw[K - 1][w] = 0;
				}
				N_k[prev_z] = N_k[K - 1];
				N_k[K - 1] = 0;
				for (int ind2 = 0; ind2<N; ind2++)	{
					if (zz[ind2] == K - 1)
						zz[ind2] = prev_z;
				}

				double tmp = pi[K - 1];
				pi[K - 1] = pi[prev_z] + pi[K];
				pi[prev_z] = tmp;
				pi[K] = 0.0;

				K--;
			}
		}
	}
	if (iter%thin == 0){
		if (iter<burnin)	printf("%d %d %lf %lf\n", iter, K, alpha0, alpha1);
		else{
			// generate theta
			for (int j = 0; j<n_j; j++)	{
				for (int k = 0; k<K; k++)
					k_vec[k] = alpha1*pi[k] + (double)N_jk[j][k];
				gsl_ran_dirichlet(r, K, k_vec, theta[j]);
			}

			// generate phi
			for (int k = 0; k<K; k++)	{
				for (int w = 0; w<W; w++)
					w_vec[w] = beta + (double)N_kw[k][w];
				gsl_ran_dirichlet(r, W, w_vec, phi[k]);
			}

			//loglik
			loglik[(iter - burnin) / thin] = 0.0;
			for (int ind2 = 0; ind2<N; ind2++)	{
				double tmp = 0.0;
				for (int k = 0; k<K; k++)	{
					tmp += theta[jj[ind2]][k] * phi[k][ww[ind2]];
				}
				loglik[(iter - burnin) / thin] += log(tmp);
			}
			loglik[(iter - burnin) / thin] /= (double)N;
			curr_loglik = loglik[(iter - burnin) / thin];

			aa0[(iter - burnin) / thin] = alpha0;
			aa1[(iter - burnin) / thin] = alpha1;
			K_vec[(iter - burnin) / thin] = K;
			printf("%d %d %lf %lf %lf\n", iter, K, alpha0, alpha1, loglik[(iter - burnin) / thin]);

			if (max_loglik<loglik[(iter - burnin) / thin]){
				max_loglik = loglik[(iter - burnin) / thin];
				max_K = K;

				for (int j = 0; j<n_j; j++)	{
					for (int k = 0; k<K; k++)
						max_theta[j][k] = theta[j][k];
				}

				for (int k = 0; k<K; k++)	{
					for (int w = 0; w<W; w++)
						max_phi[k][w] = phi[k][w];
				}

				for (int t = 0; t<N; t++)	max_zz[t] = zz[t];
			}
		}
	}
	return iter;
}// int mcmc(int iter)


void hdp::save_hdp(){

	printf("[hdp->save_hdp()] \n");

	// SAVE OUTPUTS
	FILE *ofp1, *ofp2, *ofp3, *ofp4, *ofp5, *ofp6, *ofp7;

	// ofp1 = fopen("C:\\Users\\human\\Desktop\\hdp\\K.txt", "w");
	char filepath[100];
	sprintf(filepath, "K.txt"); ofp1 = fopen(filepath, "w");
	sprintf(filepath, "loglik.txt"); ofp2 = fopen(filepath, "w");
	sprintf(filepath, "%S\\gamma.txt", folderPath); ofp3 = fopen(filepath, "w");
	sprintf(filepath, "%S\\alpha0.txt", folderPath); ofp4 = fopen(filepath, "w");
	sprintf(filepath, "%S\\pi.txt", folderPath); ofp5 = fopen(filepath, "w");
	sprintf(filepath, "%S\\phi.txt", folderPath); ofp6 = fopen(filepath, "w");
	sprintf(filepath, "%S\\z.txt", folderPath); ofp7 = fopen(filepath, "w");
	
	for (int ind = 0; ind < (max_iter - burnin) / thin; ind++)	{
		fprintf(ofp1, "%d\n", K_vec[ind]);
		fprintf(ofp2, "%lf\n", loglik[ind]);
		fprintf(ofp3, "%lf\n", aa0[ind]);
		fprintf(ofp4, "%lf\n", aa1[ind]);
	}
	for (int j = 0; j < n_j; j++)	{
		for (int k = 0; k < max_K; k++)
			fprintf(ofp5, "%lf ", max_theta[j][k]);
		fprintf(ofp5, "%\n");
	}
	for (int k = 0; k < max_K; k++)	{
		for (int w = 0; w < W; w++)
			fprintf(ofp6, "%lf ", max_phi[k][w]);
		fprintf(ofp6, "%\n");
	}
	for (int t = 0; t < N; t++)	fprintf(ofp7, "%d\n", max_zz[t]);
	fclose(ofp1);
	fclose(ofp2);
	fclose(ofp3);
	fclose(ofp4);
	fclose(ofp5);
	fclose(ofp6);
	fclose(ofp7);
}
void hdp::save_hdp2(){
	printf("[hdp->free_hdp2()] \n");

	// int n_j = 1500;
	// int max_K = 40;
	// int W = 12419;
	int text = 10;

	double **theta = (double**)malloc(n_j*sizeof(double*));
	for (int j = 0; j<n_j; j++)
		theta[j] = (double*)malloc(max_K*sizeof(double));
	double **phi = (double**)malloc(max_K*sizeof(double*));
	for (int k = 0; k<max_K; k++)
		phi[k] = (double*)malloc(W*sizeof(double));

	double **theta_t = (double**)malloc(n_j*sizeof(double*));
	for (int j = 0; j<n_j; j++)
		theta_t[j] = (double*)malloc(text*sizeof(double));

	int **idx_theta_t = (int**)malloc(n_j*sizeof(int*));
	for (int j = 0; j<n_j; j++)
		idx_theta_t[j] = (int*)malloc(text*sizeof(int));

	double **phi_t = (double**)malloc(max_K*sizeof(double*));
	for (int k = 0; k<max_K; k++)
		phi_t[k] = (double*)malloc(text*sizeof(double));

	int **idx_phi_t = (int**)malloc(max_K*sizeof(int*));
	for (int k = 0; k<max_K; k++)
		idx_phi_t[k] = (int*)malloc(text*sizeof(int));


	printf("[hdp->free_hdp2()] ifp1, ifp2 \n");
	FILE *ifp1, *ifp2;
	char filepath[200];
	// ifp1 = fopen("D:\\C code\\project\\result1\\pi.txt", "r");
	// ifp2 = fopen("D:\\C code\\project\\result1\\phi.txt", "r");
	sprintf(filepath, "%S\\pi.txt", folderPath); ifp1 = fopen(filepath, "r");
	sprintf(filepath, "%S\\phi.txt", folderPath); ifp2 = fopen(filepath, "r");

	for (int j = 0; j<n_j; j++){
		for (int k = 0; k<max_K; k++)	fscanf(ifp1, "%lf", &theta[j][k]);
	}
	for (int k = 0; k<max_K; k++){
		for (int w = 0; w<W; w++)	fscanf(ifp2, "%lf", &phi[k][w]);
	}
	fclose(ifp1);
	fclose(ifp2);

	int *index1 = (int*)malloc(W*sizeof(int));

	for (int j = 0; j<n_j; j++){
		sort(theta[j], index1, max_K, text);
		for (int k = 0; k<text; k++){
			idx_theta_t[j][k] = index1[k];
			theta_t[j][k] = theta[j][index1[k]];
		}
	}

	for (int k = 0; k<max_K; k++){
		sort(phi[k], index1, W, text);
		for (int w = 0; w<text; w++){
			idx_phi_t[k][w] = index1[w];
			phi_t[k][w] = phi[k][index1[w]];
		}
	}

	free(index1);

	printf("[hdp->free_hdp2()] ofp1, ofp2 \n");
	FILE *ofp1, *ofp2;
	// ofp1 = fopen("D:\\C code\\project\\result1\\pi_top.csv", "w");
	// ofp2 = fopen("D:\\C code\\project\\result1\\phi_top.csv", "w");
	sprintf(filepath, "%S\\pi_top.csv", folderPath); ofp1 = fopen(filepath, "w");
	sprintf(filepath, "%S\\phi_top.csv", folderPath); ofp2 = fopen(filepath, "w");

	fprintf(ofp1, "doc,topic1,prob,topic2,prob,topic3,prob,topic4,prob,topic5,prob,topic6,prob,topic7,prob,topic8,prob,topic9,prob,topic10,prob\n");
	fprintf(ofp2, "topic,word1,prob,word2,prob,word3,prob,word4,prob,word5,prob,word6,prob,word7,prob,word8,prob,word9,prob,word10,prob\n");
	for (int j = 0; j<n_j; j++){
		fprintf(ofp1, "%d", j + 1);
		for (int k = 0; k<text; k++){
			fprintf(ofp1, ",%d,%lf", idx_theta_t[j][k] + 1, theta_t[j][k]);
		}
		fprintf(ofp1, "\n");
	}

	for (int k = 0; k<max_K; k++){
		fprintf(ofp2, "%d", k + 1);
		for (int w = 0; w<text; w++){
			fprintf(ofp2, ",%d,%lf", idx_phi_t[k][w] + 1, phi_t[k][w]);
		}
		fprintf(ofp2, "\n");
	}
	fclose(ofp1);
	fclose(ofp2);


	// plot ׸
	printf("[hdp->free_hdp2()] plot \n");
	int doc[5] = { 1, 3, 5, 7, 9 };
	for (int j = 0; j<5; j++)	doc[j]--;	// Է   1 

	FILE *ofp3;
	// ofp3 = fopen("D:\\C code\\project\\result1\\plot_doc.txt", "w");
	sprintf(filepath, "plot_doc.txt"); ofp3 = fopen(filepath, "w");


	fprintf(ofp3, "doc");
	for (int k = 0; k<max_K; k++){
		fprintf(ofp3, "\tTopic_%d", k + 1);
	}
	fprintf(ofp3, "\ttotal\n");
	for (int j = 0; j<5; j++){
		fprintf(ofp3, "Doc_%d", doc[j] + 1);
		for (int k = 0; k<max_K; k++){
			fprintf(ofp3, "\t%lf", theta[doc[j]][k]);
		}
		fprintf(ofp3, "\t%lf\n", 1.0);
	}
	fclose(ofp3);

	int plot_t = 50, topic = 10;
	topic -= 1;	// Է   1 

	FILE *ofp4;
	// ofp4 = fopen("D:\\C code\\project\\result1\\plot_topic.txt", "w");
	sprintf(filepath, "plot_topic.txt"); ofp4 = fopen(filepath, "w");

	int *index4 = (int*)malloc(W*sizeof(int));
	double rest4 = 1.0;
	sort(phi[topic], index4, W, plot_t);

	fprintf(ofp4, "TOPIC");
	for (int w = 0; w<plot_t; w++){
		fprintf(ofp4, "\t Word_%d", index4[w] + 1);
	}
	fprintf(ofp4, "\t rest \t total \n");

	fprintf(ofp4, "%dth topic", topic + 1);
	for (int w = 0; w<plot_t; w++){
		fprintf(ofp4, "\t%lf", phi[topic][index4[w]]);
		rest4 -= phi[topic][index4[w]];
	}
	fprintf(ofp4, "\t%lf\t%lf\n", rest4, 1.0);

	free(index4);
	fclose(ofp4);

	for (int j = 0; j<n_j; j++){
		free(theta[j]);
		free(theta_t[j]);
		free(idx_theta_t[j]);
	}
	for (int k = 0; k<max_K; k++){
		free(phi[k]);
		free(phi_t[k]);
		free(idx_phi_t[k]);
	}
}

void hdp::free_hdp(){

	printf("[hdp->free_hdp()] \n");
	// FREE STUFFS 
	free(jj);
	free(ii);
	free(zz);
	free(ww);
	free(int_seq0);
	free(int_seq1);
	for (int k = 0; k<K_max; k++){
		free(max_phi[k]);
		free(phi[k]);
	}
	free(phi);
	for (int j = 0; j<n_j; j++){
		free(max_theta[j]);
		free(theta[j]);
	}
	free(theta);
	free(k_vec);
	free(w_vec);
	free(K_vec);
	for (int j = 0; j<n_j; j++)	{
		free(m_jk[j]);
		free(N_jk[j]);
	}
	free(m_jk);
	free(m_k);
	free(N_jk);
	free(N_k);
	for (int k = 0; k<K_max; k++)
		free(N_kw[k]);
	free(N_kw);
	free(loglik);
	free(pi);
	free(z_pr);
	for (int i = 0; i<(n_j_max + 1); i++)	{
		free(ss[i]);
		free(log_ss[i]);
	}
	free(ss);
	free(log_ss);
	free(m_pr);
	gsl_rng_free(r);

	free(w_j);
	free(s_j);
	free(aa0);
	free(aa1);
	free(max_zz);
}// save_free()
