
// hdp_mfcDlg.h :  
//

#pragma once
#include "function.h"
#include "OScopeCtrl.h"
#include "StaticGNUPlot.h"
#include<stdio.h>
#include<stdlib.h>

//n
class hdp
{ 
public:
	// Numbers
	int L;
	int W;
	int N;
	int burnin;
	int thin;
	int NN;
	int K;
	int K_max;
	int max_iter;
	int n_j;
	int n_j_max;
	double *aa0;
	double *aa1;
	double *w_j;
	double *s_j;
	// Hyperparameters
	double a0;
	double b0;
	double a1;
	double b1;
	double alpha0;
	double alpha1;
	double beta;
	double eta;
	int learn_a0;
	int learn_a1;
	// Default parameter
	int def_L;
	int def_W;
	int def_burnin;
	int def_thin;
	int def_NN;
	int def_K;
	int def_K_max;
	double def_a0;
	double def_b0;
	double def_a1;
	double def_b1;
	double def_alpha0;
	double def_alpha1;
	double def_beta;

	// Matrices and Vectors 
	int *jj;
	int *ii;
	int *zz;
	int *ww;
	int *K_vec;
	int **m_jk;
	int *N_j;
	int **N_jk;
	int **N_kw;
	int *N_k;
	int *int_seq0;
	int *int_seq1;
	int prev_z;
	int *max_zz;
	double **phi;
	double **theta;
	double curr_loglik;
	double *loglik;
	double *pi;
	double *z_pr;
	double *m_k;
	double **max_phi;
	double **max_theta;
	double *k_vec;
	double *w_vec;
	double **ss;
	double **log_ss;
	double *m_pr;
	// Random seed
	const gsl_rng_type *T;
	gsl_rng *r;
	// File
	FILE *ifp;
	// ETC
	double max_loglik;
	int max_K;
	int **data;
	bool path_loaded;
	CString folderPath;

	hdp(){
		path_loaded = false;

		// These values are computed automatically from the txt file. 
		def_L = 0; // 746316;
		def_W = 0; // 12419;

		def_burnin = 10; // 1000;
		def_thin = 2; //  10;
		def_NN = 200; // 500
		def_K = 30;
		def_K_max = 500; 
		def_a0 = 50.0; 
		def_b0 = 100.0;
		def_a1 = 100.0; 
		def_b1 = 200.0; 
		def_alpha0 = 5.0; // gamma
		def_alpha1 = 1.0; // alpha0
		def_beta = 0.02;
	}

	// INITIALIZATION of HDP
	void init(bool file_path_given);
	void init(int _L, int _W, int _burnin, int _thin, int _NN, int _K
		, double _a0, double _b0, double _a1, double _b1, double _alpha0, double _alpha1, double _beta
		, bool _learn_a0, bool _learn_a1);

	// MCMC inference for HDP
	int mcmc(int iter);

	// SAVE and FREE 
	void save_hdp();
	void save_hdp2();
	void free_hdp();

};

// Chdp_mfcDlg ȭ 
class Chdp_mfcDlg : public CDialogEx
{
// Դϴ.
public:
	Chdp_mfcDlg(CWnd* pParent = NULL);	// ǥ Դϴ.

// ȭ  Դϴ.
	enum { IDD = IDD_HDP_MFC_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV Դϴ.


// Դϴ.
protected:
	HICON m_hIcon;

	//  ޽  Լ
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

public:
// ڵ带 ۼغ. 
	// HDP
	hdp* hdp_obj;
	// ǽð plot 
	COScopeCtrl *_rtGraph, *_rtGraph2;
	// GNU plot
	CStaticGNUPlot *m_pPlot1;
	CStaticGNUPlot *m_pPlot2;
	// Thread
	bool m_bThread;
	static UINT WorkerThread(LPVOID pParam);
	// Folder path
	CString m_strPath;
	CString m_strFolderPath;
	// Btn
	bool m_bLearnA0;
	bool m_bLearnA1;
	bool m_bDefaultParam;
	bool m_bDefaultIter;
	//   gnuplot ִ 뵵 
	CStaticGNUPlot *m_pPlotLogLik;
	CStaticGNUPlot *m_pPlotK;
	CStaticGNUPlot *m_pPlotPi;
	CStaticGNUPlot *m_pPlotPhi;
	void plotResults();
	bool mcmc_done;

	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedButtonPlot();
	afx_msg void OnBnClickedButtonHdpDemo();
	afx_msg void OnBnClickedButtonHdpLoad();
	afx_msg void OnBnClickedCheckLearnA0();
	afx_msg void OnBnClickedCheckLearnA1();
	afx_msg void OnBnClickedCheckDefaultParam();
	afx_msg void OnBnClickedCheckDefaultIter();
	CString m_strStatus;
	CString m_strStatus_temp;
};
