#include "stdafx.h"
#include "hdp_mfc.h"
#include "hdp_mfcDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

UINT Chdp_mfcDlg::WorkerThread(LPVOID pParam)
{
	Chdp_mfcDlg* ptr = (Chdp_mfcDlg*)pParam;

	// Original (from Guhwan)
	// hdp_demo();

	// 1. Modulized HDP
	// 1.1 Init HDP

	int _L = ptr->hdp_obj->def_L;
	int _W = ptr->hdp_obj->def_W;
	CString str; double val;
	ptr->GetDlgItem(IDC_EDIT_BURNIN)->GetWindowText(str);  val = _wtof(str); int _burnin = (int)val;
	ptr->GetDlgItem(IDC_EDIT_THIN)->GetWindowText(str);  val = _wtof(str); int _thin = (int)val;
	ptr->GetDlgItem(IDC_EDIT_N)->GetWindowText(str);  val = _wtof(str); int _NN = (int)val;
	ptr->GetDlgItem(IDC_EDIT_K)->GetWindowText(str);  val = _wtof(str); int _K = (int)val;

	ptr->GetDlgItem(IDC_EDIT_A0)->GetWindowText(str);  val = _wtof(str); double _a0 = val;
	ptr->GetDlgItem(IDC_EDIT_B0)->GetWindowText(str);  val = _wtof(str); double _b0 = val;
	ptr->GetDlgItem(IDC_EDIT_A1)->GetWindowText(str);  val = _wtof(str); double _a1 = val;
	ptr->GetDlgItem(IDC_EDIT_B1)->GetWindowText(str);  val = _wtof(str); double _b1 = val;
	ptr->GetDlgItem(IDC_EDIT_ALPHA0)->GetWindowText(str);  val = _wtof(str); double _alpha0 = val;
	ptr->GetDlgItem(IDC_EDIT_ALPHA1)->GetWindowText(str);  val = _wtof(str); double _alpha1 = val;
	ptr->GetDlgItem(IDC_EDIT_BETA)->GetWindowText(str);  val = _wtof(str); double _beta = val;
	bool _learn_a0 = ptr->m_bLearnA0;
	bool _learn_a1 = ptr->m_bLearnA1;
	
	
	printf("\n[WorkerThread] Init HDP \n");
	printf("L: %d W: %d \n", _L, _W); 
	printf("Burnin: %d Thin: %d NN: %d \n", _burnin, _thin, _NN);
	printf("a0: %.1f b0: %.1f a1: %.1f b1: %.1f alpha0: %.1f alpha1: %.1f beta: %.1f \n", _a0, _b0, _a1, _b1, _alpha0, _alpha1, _beta);
	ptr->hdp_obj->init(_L, _W, _burnin, _thin, _NN, _K, _a0, _b0, _a1, _b1, _alpha0, _alpha1, _beta, _learn_a0, _learn_a1);

	ptr->m_strStatus_temp.Format(L"Total Item (L): %d Dictionary Size (W): %d \r\n", ptr->hdp_obj->L, ptr->hdp_obj->W);
	ptr->m_strStatus += ptr->m_strStatus_temp;
	ptr->m_strStatus_temp.Format(L"a0: %.1f b0: %.1f a1: %.1f b1: %.1f alpha0: %.1f alpha1: %.1f beta: %.1f \r\n"
		, _a0, _b0, _a1, _b1, _alpha0, _alpha1, _beta);
	ptr->m_strStatus += ptr->m_strStatus_temp;

	int iter = 0;
	int max_iter = ptr->hdp_obj->max_iter;
	// 2.2 MCMC HDP
	ptr->m_strStatus_temp.Format(L"Starting MCMC for HDP Burnin: %d Thin: %d NN: %d \r\n"
		, ptr->hdp_obj->burnin, ptr->hdp_obj->thin, ptr->hdp_obj->NN);
	ptr->m_strStatus += ptr->m_strStatus_temp;
	while (1)
	{
		// printf("[WorkerThread] [%d/%d] \n", iter, max_iter);
		// MCMC Ѵ. 
		CString str; str.Format(L"%d/%d", iter+1, max_iter);
		ptr->GetDlgItem(IDC_EDIT_ITERATION)->SetWindowText(str);
		ptr->hdp_obj->mcmc(iter++);

		// 2.2.1 Log Lik ׸. 
		double LL = ptr->hdp_obj->curr_loglik;
		if (LL != 0)
			ptr->_rtGraph->AppendPoints(&LL);

		// 2.2.2 Log Lik ׸. 
		double dK = (double)(ptr->hdp_obj->K);
		if (dK != 0)
			ptr->_rtGraph2->AppendPoints(&dK);

		// 2.2.3  ó 
		if (iter >= max_iter)
		{
			printf("[WorkerThread] Max iteration %d reached \n", iter);
			break;
		}
		Sleep(0);
	}
	// 2.3 SAVE RESULTS
	ptr->hdp_obj->save_hdp();
	ptr->hdp_obj->save_hdp2();
	// 2.4 FREE
	ptr->hdp_obj->free_hdp();
	//AfxMessageBox(L"HDP using MCMC Finished");

	ptr->m_strStatus_temp.Format(L"HDP using MCMC Finished \r\n");
	ptr->m_strStatus += ptr->m_strStatus_temp;

	ptr->m_bThread = false;
	// 3. PLOT
	ptr->plotResults();
	ptr->mcmc_done = true;
	return 0L;
}


